# use module flask and flask-cors
# pip install flask
# pip install flask-cors
# documentation
# - http://flask-cors.readthedocs.org/en/latest/ manage problem Access-Control-Allow-Origin
# - http://flask.pocoo.org/

from flask import Flask
from flask import jsonify
from flask import json
from flask import request
from flask.ext.cors import CORS

# data sample for Mascarille
import data

app = Flask(__name__)
cors = CORS(app)

INIT = {
    'api' :
    {
        'play' : 'http://localhost:5000/play',
        'author' : 'http://localhost:5000/author',
        'book' : 'http://localhost:5000/book',
        'publisher' : 'http://localhost:5000/publisher',
    },
    'play' :
    {
        'totaldistributmin' : 0,
        'totaldistributmax' : 100,
        'maledistributmin' : 0,
        'maledistributmax' : 100,
        'femaledistributmin' : 0,
        'femaledistributmax' : 100,
        'childdistributmin' : 0,
        'childdistributmax' : 100,
        'yearsplaymin' : 0,
        'yearsplaymax' : 2050,
    },
    'author' :
    {
        'birthdaymin' : 0,
        'birthdaymax' : 2050,
        'deaddaymin' : 0,
        'deaddaymax' : 2050,
    }
}

@app.errorhandler(404)
def not_found(error=None, msg=''):
    message = {
            'status': 404,
            'message': 'Not Found: ' + msg,
    }
    resp = jsonify(message)
    resp.status_code = 404
    return resp

@app.route('/init', methods = ['GET'])
def api_init():
    return json.dumps(INIT)

@app.route('/play', methods = ['POST'])
def api_play():
    query = json.loads(request.data.decode())
    print(query)
    return json.dumps([{"msg":"%s pieces trouvees" % len(data.PLAYS),
                        "result" : data.PLAYS}])

@app.route('/author', methods = ['POST'])
def api_author():
    query = json.loads(request.data.decode())
    print(query)
    return json.dumps([{"msg":"%s auteurs trouves" % len(data.AUTHORS),
                        "result" : data.AUTHORS}])

@app.route('/publisher', methods = ['POST'])
def api_publisher():
    query = json.loads(request.data.decode())
    print(query)
    return json.dumps([{"msg":"%s editeurs trouves" % len(data.PUBLISHERS),
                        "result" : data.PUBLISHERS}])

@app.route('/book', methods = ['POST'])
def api_book():
    query = json.loads(request.data.decode())
    print(query)
    return json.dumps([{"msg":"%s livres trouves" % len(data.BOOKS),
                        "result" : data.BOOKS}])

if __name__ == '__main__':
    app.run()
